From f3a729fad9e2a54e0efd83c57562791ab49b4317 Mon Sep 17 00:00:00 2001
From: Petr Jelinek <pjmodos@pjmodos.net>
Date: Wed, 13 Jul 2016 20:00:06 +0200
Subject: [PATCH 5/6] Add logical replication workers

---
 doc/src/sgml/catalogs.sgml                         |    8 +-
 doc/src/sgml/filelist.sgml                         |    1 +
 doc/src/sgml/logical-replication.sgml              |  361 +++++
 doc/src/sgml/postgres.sgml                         |    1 +
 doc/src/sgml/reference.sgml                        |    6 +
 src/backend/commands/subscriptioncmds.c            |  175 ++-
 src/backend/executor/nodeModifyTable.c             |    6 +-
 src/backend/postmaster/bgworker.c                  |    6 +-
 src/backend/postmaster/postmaster.c                |   41 +
 .../libpqwalreceiver/libpqwalreceiver.c            |   28 +-
 src/backend/replication/logical/Makefile           |    5 +-
 src/backend/replication/logical/apply.c            | 1435 ++++++++++++++++++++
 src/backend/replication/logical/launcher.c         |  542 ++++++++
 src/backend/storage/ipc/ipci.c                     |    3 +
 src/backend/storage/lmgr/lwlocknames.txt           |    1 +
 src/backend/utils/misc/guc.c                       |   22 +
 src/include/executor/nodeModifyTable.h             |   20 +
 src/include/postmaster/bgworker_internals.h        |    2 +
 src/include/replication/logicalworker.h            |   41 +
 src/include/replication/walreceiver.h              |    4 +
 src/test/perl/PostgresNode.pm                      |   10 +-
 src/test/subscription/.gitignore                   |    2 +
 src/test/subscription/Makefile                     |   20 +
 src/test/subscription/README                       |   16 +
 src/test/subscription/t/001_rep_changes.pl         |   89 ++
 src/test/subscription/t/002_types.pl               |  509 +++++++
 26 files changed, 3338 insertions(+), 16 deletions(-)
 create mode 100644 doc/src/sgml/logical-replication.sgml
 create mode 100644 src/backend/replication/logical/apply.c
 create mode 100644 src/backend/replication/logical/launcher.c
 create mode 100644 src/include/replication/logicalworker.h
 create mode 100644 src/test/subscription/.gitignore
 create mode 100644 src/test/subscription/Makefile
 create mode 100644 src/test/subscription/README
 create mode 100644 src/test/subscription/t/001_rep_changes.pl
 create mode 100644 src/test/subscription/t/002_types.pl

diff --git a/doc/src/sgml/catalogs.sgml b/doc/src/sgml/catalogs.sgml
index 84211c1..5951716 100644
--- a/doc/src/sgml/catalogs.sgml
+++ b/doc/src/sgml/catalogs.sgml
@@ -5134,7 +5134,8 @@
 
   <para>
    The <structname>pg_publication</structname> catalog contains
-   all publications created in the database.
+   all publications created in the database.  For more on publications
+   see <xref linkend="logical-replication-publication">.
   </para>
 
   <table>
@@ -6051,7 +6052,8 @@
 
   <para>
    The <structname>pg_subscription</structname> catalog contains
-   all existing logical replication subscriptions.
+   all existing logical replication subscriptions.  For more information
+   about logical replication see <xref linkend="logical-replication">.
   </para>
 
   <para>
@@ -6120,7 +6122,7 @@
       <entry><type>text[]</type></entry>
       <entry></entry>
       <entry>Array of subscribed publication names. For more on publications
-       see <xref linkend="publications">.
+       see <xref linkend="logical-replication-publication">.
       </entry>
      </row>
     </tbody>
diff --git a/doc/src/sgml/filelist.sgml b/doc/src/sgml/filelist.sgml
index 4383711..7067a21 100644
--- a/doc/src/sgml/filelist.sgml
+++ b/doc/src/sgml/filelist.sgml
@@ -49,6 +49,7 @@
 <!ENTITY config        SYSTEM "config.sgml">
 <!ENTITY user-manag    SYSTEM "user-manag.sgml">
 <!ENTITY wal           SYSTEM "wal.sgml">
+<!ENTITY logical-replication    SYSTEM "logical-replication.sgml">
 
 <!-- programmer's guide -->
 <!ENTITY bgworker   SYSTEM "bgworker.sgml">
diff --git a/doc/src/sgml/logical-replication.sgml b/doc/src/sgml/logical-replication.sgml
new file mode 100644
index 0000000..3179add
--- /dev/null
+++ b/doc/src/sgml/logical-replication.sgml
@@ -0,0 +1,361 @@
+<!-- doc/src/sgml/logical-replication.sgml -->
+
+<chapter id="logical-replication">
+
+  <title>Logical Replication</title>
+  <para>
+    Logical Replication is a method of replicating data objects and their
+    changes, based upon their Primary Keys (or Replication Identity). We
+    use the term Logical in contrast to Physical replication which
+    uses exact block addresses and byte-by-byte replication.
+    PostgreSQL supports both mechanisms concurrently, see
+    <xref linkend="high-availability">. Logical Replication allows
+    fine-grained control over both data replication and security.
+  </para>
+  <para>
+    Logical Replication uses a Publish and Subscribe model with one or
+    more Subscribers subscribing to one or more Publications on a
+    Provider node. Subscribers pull data from the Publications they
+    subscribe to and may subsequently re-publish data to allow
+    cascading replication or more complex configurations.
+  </para>
+  <para>
+    Logical replication typically starts with snapshot of the data on
+    the Provider database. Once that is done, the changes on Provider
+    are sent to Subscriber as they occur in real-time. The Subscriber
+    applies the data in same order as the Provider so that the
+    transactional consistency is guaranteed for the Publications within
+    single Subscription. This method of data replication is sometimes
+    referred to as transactional replication.
+  </para>
+  <para>
+    The typical use-cases for logical replication are:
+  </para>
+  <itemizedlist>
+    <listitem>
+      <para>
+        Sending incremental changes in a single database or a subset of
+        a database to Subscribers as they occur.
+      </para>
+    </listitem>
+    <listitem>
+      <para>
+        Firing triggers for individual changes as they are incoming to
+        subscriber.
+      </para>
+    </listitem>
+    <listitem>
+      <para>
+        Consolidating multiple databases into a single one (for example
+        for analytical purposes).
+      </para>
+    </listitem>
+    <listitem>
+      <para>
+        Replicating between different major versions of the PostgreSQL
+      </para>
+    </listitem>
+    <listitem>
+      <para>
+        Giving access to the replicated data to different groups of
+        users.
+      </para>
+    </listitem>
+    <listitem>
+      <para>
+        Sharing subset of the database between multiple databases.
+      </para>
+    </listitem>
+  </itemizedlist>
+  <para>
+    The Subscriber database behaves in a same way as any other
+    PostgreSQL instance and can be used as a Provider for other
+    databases by defining its own Publications. When the Subscriber is
+    treated as read-only by application, there will be no conflicts from
+    a single Subscription. On the other hand if there are other writes
+    done either by application or other Subscribers to the same set of
+    tables conflicts can arise.
+  </para>
+
+<sect1 id="logical-replication-publication">
+  <title>Publication</title>
+  <para>
+    A Publication object can be defined on any master node, owned by one
+    user. A Publication is a set of changes generated from a group of
+    tables, and might also be described as a Change Set or Replication Set.
+    Each Publication exists in only one database.
+  </para>
+  <para>
+    Publications are different from table schema and do not affect
+    how the table is accessed. Each table can be added to multiple
+    Publications if needed.  Publications may include both tables
+    and materialized views. Objects must be added explicitly, except
+    when a Publication is created for "ALL TABLES". There is no
+    default name for a Publication which specifies all tables.
+  </para>
+  <para>
+    The Publication is different from table schema, it does not affect
+    how the table is accessed and each table can be added to multiple
+    Publications as needed. All tables in the database can be added to
+    single Publication. Since the logical replication requires REPLICA
+    IDENTITY index to be present on a table for replication of UPDATEs
+    and DELETEs, the table without such index can't be added to
+    Publication which replicates UPDATEs and DELETEs.
+  </para>
+  <para>
+    Publications can choose to limit the changes they produce to show
+    any combination of INSERT, UPDATE, DELETE and TRUNCATE in a similar
+    way to the way triggers are fired by particular event types.
+  </para>
+  <para>
+    All tables added to the Publication must be accessible via SELECT
+    privilege for the user owning the Publication. Usage on the
+    Publication can be GRANTed to other users.
+  </para>
+  <para>
+    The definition of a Publication object will be included within
+    pg_dump.
+  </para>
+  <para>
+    Every Publication can have multiple Subscribers.
+  </para>
+  <para>
+    Publication is created using the <xref linkend="sql-createpublication">
+    command and may be later altered or dropped using corresponding commands.
+  </para>
+  <para>
+    The individual tables can be added and removed dynamically using
+    <xref linkend="sql-alterpublication">. Both the ADD TABLE and DROP
+    TABLE operations are transactional so the table will start or stop
+    replicating at the correct snapshot once the transaction has committed.
+  </para>
+</sect1>
+<sect1 id="logical-replication-subscription">
+  <title>Subscription</title>
+  <para>
+    A Subscription is the downstream side of the Logical Replication. The
+    node where Subscription is defined is referred to as a Subscriber.
+    Subscription defines the connection to another database and set of
+    Publications (one or more) to which it wants to be subscribed.
+  </para>
+  <para>
+    The Subscriber database behaves in a same way as any other
+    PostgreSQL instance and can be used as a Provider for other
+    databases by defining its own Publications.
+  </para>
+  <para>
+    A Subscriber may have multiple Subscriptions if desired. It is
+    possible to define multiple Subscriptions between single
+    Provider-Subscriber pair, provided that each Publications can only
+    be subscribed to from one Subscriber.
+  </para>
+  <para>
+    Each Subscription will receive changes via one replication slot (see
+    <xref linkend="streaming-replication-slots">). Additional temporary
+    replication slots may be required for the initial data synchronizations
+    of pre-existing table data.
+  </para>
+  <para>
+    Subscriptions are not dumped by pg_dump by default, but can be
+    requested using --subscriptions parameter.
+  </para>
+  <para>
+    The Subscription is added using <xref linkend="sql-createsubscription">
+    and can be stopped/resumed at any time using
+    <xref linkend="sql-altersubscription"> command or removed using
+    <xref linkend="sql-dropsubscription">.
+  </para>
+  <para>
+    When subscription is dropped and recreated the synchronization
+    information is lost. This means that the data has to be
+    resynchronized afterwards.
+  </para>
+</sect1>
+<sect1 id="logical-replication-conflicts">
+  <title>Conflicts</title>
+  <para>
+    Conflicts happen when the replicated changes is breaking any
+    specified constraints (with the exception of foreign keys which are
+    not checked). Currently conflicts are not resolved automatically and
+    cause replication to be stopped with an error until the conflict is
+    manually resolved.
+  </para>
+</sect1>
+<sect1 id="logical-replication-architecture">
+  <title>Architecture</title>
+  <para>
+    Logical replication starts by copying a snapshot of the data on
+    the Provider database. Once that is done, the changes on Provider
+    are sent to Subscriber as they occur in real-time. The Subscriber
+    applies the data in the order in which commits were made on the
+    Provider so that transactional consistency is guaranteed for the
+    Publications within any single Subscription.
+  </para>
+  <para>
+    The Logical Replication is built on the similar architecture as the
+    physical streaming replication
+    (see <xref linkend="streaming-replication">). It is implemented by
+    WalSender and the Apply processes. The WalSender starts the logical
+    decoding (described in <xref linkend="logicaldecoding">) of the WAL and
+    loads the standard logical decoding plugin (pgoutput). The plugin
+    transforms the changes read from WAL to the logical replication protocol
+    (see <xref linkend="protocol-logical-replication">) and filters the data
+    according to Publication specifications. The data are then continuously
+    transferred using the streaming replication protocol to the Apply worker
+    which maps them to the local tables and applies the individual changes as
+    they are received in exact transactional order.
+  </para>
+  <para>
+    The Apply process on Subscriber database always runs with
+    session_replication_role set to replica, which produces the normal effects
+    on triggers and constraints.
+  </para>
+  <sect2 id="logical-replication-snapshot">
+    <title>Initial snapshot</title>
+    <para>
+      The initial snapshot is taken when the replication slot for
+      Subscription is created. The existing data at that snapshot are
+      then sent over using the streaming replication protocol between
+      WalSender and Apply processes in similar way the changes are sent.
+      Once the initial data are copied, the Apply enters catch up phase
+      where it replays the changes which happened on the Provider while
+      the initial snapshot was being copied. Once the replication catches
+      up the Apply switches to normal replication streaming mode and
+      replicates transactions as they happen.
+    </para>
+  </sect2>
+  <sect2 id="logical-replication-table-resync">
+    <title>Individual table resynchronization</title>
+    <para>
+      The table can be resynchronized at any point during the normal
+      replication operation. When the table resynchronization is
+      requested a parallel instance of special kind of the Apply process
+      is started which registers its own temporary replication slot and
+      does new snapshot. Then it works same way as the initial snapshot
+      <xref linkend="logical-replication-snapshot"> with the exception that
+      it only does data copy of single table and once the catchup phase is
+      finished the control of the replication of the table is given back to
+      the main Apply process.
+    </para>
+  </sect2>
+</sect1>
+<sect1 id="logical-replication-monitoring">
+  <title>Monitoring</title>
+  <para>
+    pg_stat_replication
+  </para>
+  <para>
+    pg_stat_subscription
+  </para>
+</sect1>
+<sect1 id="logical-replication-security">
+  <title>Security</title>
+  <para>
+    Replication connection can occur in the same way as physical streaming
+    replication. It requires access to be specifically given using
+    pg_hba.conf. The role used for the replication must have
+    <literal>REPLICATION</literal> privilege <command>GRANTED</command>.
+    This gives a role access to both logical and physical replication.
+  </para>
+  <para>
+    In addition, logical replication can be accessed with the
+    <literal>SUBSCRIPTION</literal> privilege. This allows you to create
+    roles which can pull data from Publications yet cannot request
+    physical replication.
+  </para>
+  <para>
+    To create or subscribe to a Publication the user must have the
+    REPLICATION role, the SUBSCRIPTION role or be a superuser.
+  </para>
+  <para>
+    <literal>SELECT</literal> privilege is required when the user
+    adds a table to a Publication.
+    To subscribe to a Publication, user must be owner or have USAGE
+    privileges granted to the Publication.
+  </para>
+  <para>
+    To create a Subscription the user must have the
+    REPLICATION role, the SUBSCRIPTION role or be a superuser.
+    The Subscription Apply process will run in local database
+    with the privileges of the owner of the Subscription. In practice this
+    means that the owner of the Subscription must have <literal>INSERT</>,
+    <literal>UPDATE</>, <literal>DELETE</> and <literal>TRUNCATE</>
+    privileges on Subscriber to the tables that are being replicated by the
+    Subscription, or be superuser, though this is not recommended.
+  </para>
+  <para>
+    In particular, note that privileges are not re-checked as each change
+    record is read from the Provider, nor are they re-checked for each change
+    when applied. Security is checked once at startup. Concurrent REVOKEs
+    of privilege will interrupt logical replication if they have a material
+    affect on the security of the change stream.
+  </para>
+</sect1>
+<sect1 id="logical-replication-gucs">
+  <title>Logical replication related configuration parameters</title>
+  <para>
+    The Logical Replication requires several configuration options to be
+    set.
+  </para>
+  <para>
+    On the provider side the <varname>wal_level</> must be set to
+    <literal>logical</>, <varname>max_replication_slots</> has to be set to
+    at least number of Subscriptions expected to connect with some reserve
+    for table synchronization as well. And <varname>max_wal_senders</>
+    should be set to at least same as <varname>max_replication_slots</> plus
+    the number of physical replicas that are connected at the same time.
+  </para>
+  <para>
+    The Subscriber also requires the <varname>max_replication_slots</> to
+    be set. In this case it should be set to at least the number of
+    Subscriptions that will be added to the Subscriber. The
+    <varname>max_logical_replication_workers</> has to be set to at least
+    the number of Subscriptions again with some reserve for the table
+    synchronization. Additionally the <varname>max_worker_processes</> may
+    need to be adjusted to accommodate for replication workers at least
+    (<varname>max_logical_replication_workers</> + <literal>1</>). Please
+    note that some extensions and parallel queries also take worker slots
+    from <varname>max_worker_processes</>.
+  </para>
+</sect1>
+<sect1 id="logical-replication-quick-setup">
+  <title>Quick setup</title>
+  <para>
+    First set the configuration options in the postgresql.conf:
+<programlisting>
+wal_level = logical
+max_worker_processes = 10 # one per subscription + one per instance needed on subscriber
+max_logical_replication_workers = 10 # one per subscription + one per instance needed on subscriber
+max_replication_slots = 10 # one per subscription needed both provider and subscriber
+max_wal_senders = 10 # one per subscription needed on provider
+</programlisting>
+  </para>
+  <para>
+    The pg_hba.conf needs to be adjusted to allow replication (the
+    values here depend on your actual network configuration and user you
+    want to use for connecting):
+<programlisting>
+host    replication     repuser     0.0.0.0/0       md5
+</programlisting>
+  </para>
+  <para>
+    Then on Provider database:
+<programlisting>
+CREATE PUBLICATION mypub;
+ALTER PUBLICATION mypub ADD TABLE users, departments;
+</programlisting>
+  </para>
+  <para>
+    And on Subscriber database:
+<programlisting>
+CREATE SUBSCRIPTION mysub WITH CONNECTION <quote>dbname=foo host=bar user=repuser</quote> PUBLICATION mypub;
+</programlisting>
+  </para>
+  <para>
+    The above will start the replication process which synchronizes the
+    initial table contents of <literal>users</literal> and
+    <literal>departments</literal> tables and then starts replicating
+    incremental changes to those tables.
+  </para>
+</sect1>
+</chapter>
diff --git a/doc/src/sgml/postgres.sgml b/doc/src/sgml/postgres.sgml
index 0346d36..1c94015 100644
--- a/doc/src/sgml/postgres.sgml
+++ b/doc/src/sgml/postgres.sgml
@@ -159,6 +159,7 @@
   &monitoring;
   &diskusage;
   &wal;
+  &logical-replication;
   &regress;
 
  </part>
diff --git a/doc/src/sgml/reference.sgml b/doc/src/sgml/reference.sgml
index 8acdff1..34007d3 100644
--- a/doc/src/sgml/reference.sgml
+++ b/doc/src/sgml/reference.sgml
@@ -54,11 +54,13 @@
    &alterOperatorClass;
    &alterOperatorFamily;
    &alterPolicy;
+   &alterPublication;
    &alterRole;
    &alterRule;
    &alterSchema;
    &alterSequence;
    &alterServer;
+   &alterSubscription;
    &alterSystem;
    &alterTable;
    &alterTableSpace;
@@ -100,11 +102,13 @@
    &createOperatorClass;
    &createOperatorFamily;
    &createPolicy;
+   &createPublication;
    &createRole;
    &createRule;
    &createSchema;
    &createSequence;
    &createServer;
+   &createSubscription;
    &createTable;
    &createTableAs;
    &createTableSpace;
@@ -144,11 +148,13 @@
    &dropOperatorFamily;
    &dropOwned;
    &dropPolicy;
+   &dropPublication;
    &dropRole;
    &dropRule;
    &dropSchema;
    &dropSequence;
    &dropServer;
+   &dropSubscription;
    &dropTable;
    &dropTableSpace;
    &dropTSConfig;
diff --git a/src/backend/commands/subscriptioncmds.c b/src/backend/commands/subscriptioncmds.c
index 54d66d5..43e2853 100644
--- a/src/backend/commands/subscriptioncmds.c
+++ b/src/backend/commands/subscriptioncmds.c
@@ -29,13 +29,19 @@
 #include "catalog/pg_subscription.h"
 
 #include "commands/defrem.h"
+#include "commands/replicationcmds.h"
 
 #include "executor/spi.h"
 
 #include "nodes/makefuncs.h"
 
+#include "replication/logical.h"
+#include "replication/logicalproto.h"
+#include "replication/logicalworker.h"
+#include "replication/origin.h"
 #include "replication/reorderbuffer.h"
-#include "commands/replicationcmds.h"
+#include "replication/logicalworker.h"
+#include "replication/walreceiver.h"
 
 #include "utils/array.h"
 #include "utils/builtins.h"
@@ -164,7 +170,12 @@ CreateSubscription(CreateSubscriptionStmt *stmt)
 	bool		enabled_given;
 	bool		enabled;
 	char	   *conninfo;
+	char	   *slotname;
 	List	   *publications;
+	WalReceiverConnHandle  *wrchandle = NULL;
+	WalReceiverConnAPI	   *wrcapi = NULL;
+	walrcvconn_init_fn		walrcvconn_init;
+	XLogRecPtr	lsn;
 
 	check_replication_permissions();
 
@@ -184,6 +195,7 @@ CreateSubscription(CreateSubscriptionStmt *stmt)
 	/* Parse and check options. */
 	parse_subscription_options(stmt->options, &enabled_given, &enabled,
 							   &conninfo, &publications);
+	slotname = stmt->subname;
 
 	/* TODO: improve error messages here. */
 	if (conninfo == NULL)
@@ -202,7 +214,7 @@ CreateSubscription(CreateSubscriptionStmt *stmt)
 
 	values[Anum_pg_subscription_dbid - 1] = ObjectIdGetDatum(MyDatabaseId);
 	values[Anum_pg_subscription_subname - 1] =
-		DirectFunctionCall1(namein, CStringGetDatum(stmt->subname));
+		DirectFunctionCall1(namein, CStringGetDatum(slotname));
 	values[Anum_pg_subscription_subenabled - 1] = BoolGetDatum(enabled);
 	values[Anum_pg_subscription_subconninfo - 1] =
 		CStringGetTextDatum(conninfo);
@@ -218,13 +230,47 @@ CreateSubscription(CreateSubscriptionStmt *stmt)
 	CatalogUpdateIndexes(rel, tup);
 	heap_freetuple(tup);
 
-	ObjectAddressSet(myself, SubscriptionRelationId, suboid);
+	/*
+	 * Now that the catalog update is done, try to reserve slot at the
+	 * provider node using replication connection.
+	 */
+	wrcapi = palloc0(sizeof(WalReceiverConnAPI));
+
+	walrcvconn_init = (walrcvconn_init_fn)
+		load_external_function("libpqwalreceiver",
+							   "_PG_walreceirver_conn_init", false, NULL);
+
+	if (walrcvconn_init == NULL)
+		elog(ERROR, "libpqwalreceiver does not declare _PG_walreceirver_conn_init symbol");
+
+	wrchandle = walrcvconn_init(wrcapi);
+	if (wrcapi->connect == NULL ||
+		wrcapi->create_slot == NULL)
+		elog(ERROR, "libpqwalreceiver didn't initialize correctly");
+
+	wrcapi->connect(wrchandle, conninfo, true, stmt->subname);
+	wrcapi->create_slot(wrchandle, slotname, true, &lsn);
+	ereport(NOTICE,
+			(errmsg("created replication slot \"%s\" on provider",
+					slotname)));
+	/*
+	 * Setup replication origin tracking.
+	 * TODO: do this only when it does not already exist?
+	 */
+	replorigin_create(slotname);
+
+	/* And we are done with the remote side. */
+	wrcapi->disconnect(wrchandle);
 
 	heap_close(rel, RowExclusiveLock);
 
 	/* Make the changes visible. */
 	CommandCounterIncrement();
 
+	ApplyLauncherWakeupOnCommit();
+
+	ObjectAddressSet(myself, SubscriptionRelationId, subid);
+
 	return myself;
 }
 
@@ -302,6 +348,11 @@ AlterSubscription(AlterSubscriptionStmt *stmt)
 	heap_freetuple(tup);
 	heap_close(rel, RowExclusiveLock);
 
+	/* Make the changes visible. */
+	CommandCounterIncrement();
+
+	ApplyLauncherWakeupOnCommit();
+
 	return myself;
 }
 
@@ -313,19 +364,135 @@ DropSubscriptionById(Oid subid)
 {
 	Relation	rel;
 	HeapTuple	tup;
+	Datum		datum;
+	bool		isnull;
+	char	   *subname;
+	char	   *conninfo;
+	char	   *slotname;
+	TupleDesc	tupdesc;
+	RepOriginId	originid;
+	MemoryContext			tmpctx,
+							oldctx;
+	WalReceiverConnHandle  *wrchandle = NULL;
+	WalReceiverConnAPI	   *wrcapi = NULL;
+	walrcvconn_init_fn		walrcvconn_init;
 
 	check_replication_permissions();
 
 	rel = heap_open(SubscriptionRelationId, RowExclusiveLock);
 
+	if (GetTopTransactionIdIfAny() != InvalidTransactionId)
+		ereport(ERROR,
+				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
+				 errmsg("DROP SUBSCRIPTION must be first action in transaction")));
+
 	tup = SearchSysCache1(SUBSCRIPTIONOID, ObjectIdGetDatum(subid));
 
 	if (!HeapTupleIsValid(tup))
 		elog(ERROR, "cache lookup failed for subscription %u", subid);
 
+	tupdesc = RelationGetDescr(rel);
+
+	/*
+	 * Create temporary memory context to keep copy of subscription
+	 * info needed later in the execution.
+	 */
+	tmpctx = AllocSetContextCreate(TopMemoryContext,
+										  "DropSubscription Ctx",
+										  ALLOCSET_DEFAULT_MINSIZE,
+										  ALLOCSET_DEFAULT_INITSIZE,
+										  ALLOCSET_DEFAULT_MAXSIZE);
+	oldctx = MemoryContextSwitchTo(tmpctx);
+
+	/* Get subname */
+	datum = heap_getattr(tup, Anum_pg_subscription_subname, tupdesc,
+						 &isnull);
+	Assert(!isnull);
+	subname = pstrdup(NameStr(*DatumGetName(datum)));
+
+	/* Get conninfo */
+	datum = heap_getattr(tup, Anum_pg_subscription_subconninfo, tupdesc,
+						 &isnull);
+	Assert(!isnull);
+	conninfo = pstrdup(TextDatumGetCString(datum));
+
+	/* Get slotname */
+	datum = heap_getattr(tup, Anum_pg_subscription_subslotname, tupdesc,
+						 &isnull);
+	Assert(!isnull);
+	slotname = pstrdup(NameStr(*DatumGetName(datum)));
+
+	MemoryContextSwitchTo(oldctx);
+
+	/* Remove the tuple from catalog. */
 	simple_heap_delete(rel, &tup->t_self);
 
 	ReleaseSysCache(tup);
 
-	heap_close(rel, RowExclusiveLock);
+	heap_close(rel, NoLock);
+
+	originid = replorigin_by_name(slotname, true);
+	if (originid != InvalidRepOriginId)
+		replorigin_drop(originid);
+
+	/* Commit the transaction to make the change visible to laucnher. */
+	PopActiveSnapshot();
+	CommitTransactionCommand();
+
+	/* Signal the launcher so that it kills the apply proccess. */
+	ApplyLauncherWakeup();
+
+	StartTransactionCommand();
+
+	/*
+	 * Now that the catalog update is done, try to reserve slot at the
+	 * provider node using replication connection.
+	 */
+	wrcapi = palloc0(sizeof(WalReceiverConnAPI));
+
+	walrcvconn_init = (walrcvconn_init_fn)
+		load_external_function("libpqwalreceiver",
+							   "_PG_walreceirver_conn_init", false, NULL);
+
+	if (walrcvconn_init == NULL)
+		elog(ERROR, "libpqwalreceiver does not declare _PG_walreceirver_conn_init symbol");
+
+	wrchandle = walrcvconn_init(wrcapi);
+	if (wrcapi->connect == NULL ||
+		wrcapi->drop_slot == NULL)
+		elog(ERROR, "libpqwalreceiver didn't initialize correctly");
+
+	/*
+	 * We must ignore error as that would make it impossible to drop
+	 * subscription when provider is down.
+	 */
+	oldctx = CurrentMemoryContext;
+	PG_TRY();
+	{
+		wrcapi->connect(wrchandle, conninfo, true, subname);
+		wrcapi->drop_slot(wrchandle, slotname);
+		ereport(NOTICE,
+				(errmsg("dropped replication slot \"%s\" on provider",
+						slotname)));
+		wrcapi->disconnect(wrchandle);
+	}
+	PG_CATCH();
+	{
+		MemoryContext	ectx;
+		ErrorData	   *edata;
+
+		ectx = MemoryContextSwitchTo(oldctx);
+		/* Save error info */
+		edata = CopyErrorData();
+		MemoryContextSwitchTo(ectx);
+		FlushErrorState();
+
+		ereport(WARNING,
+				(errmsg("there was problem dropping the replication slot "
+						"\"%s\" on provider", slotname),
+				 errdetail("The error was: %s", edata->message),
+				 errhint("You may have to drop it manually")));
+		FreeErrorData(edata);
+	}
+	PG_END_TRY();
 }
diff --git a/src/backend/executor/nodeModifyTable.c b/src/backend/executor/nodeModifyTable.c
index af7b26c..907623b 100644
--- a/src/backend/executor/nodeModifyTable.c
+++ b/src/backend/executor/nodeModifyTable.c
@@ -232,7 +232,7 @@ ExecCheckTIDVisible(EState *estate,
  *		Returns RETURNING result if any, otherwise NULL.
  * ----------------------------------------------------------------
  */
-static TupleTableSlot *
+TupleTableSlot *
 ExecInsert(ModifyTableState *mtstate,
 		   TupleTableSlot *slot,
 		   TupleTableSlot *planSlot,
@@ -536,7 +536,7 @@ ExecInsert(ModifyTableState *mtstate,
  *		Returns RETURNING result if any, otherwise NULL.
  * ----------------------------------------------------------------
  */
-static TupleTableSlot *
+TupleTableSlot *
 ExecDelete(ItemPointer tupleid,
 		   HeapTuple oldtuple,
 		   TupleTableSlot *planSlot,
@@ -794,7 +794,7 @@ ldelete:;
  *		Returns RETURNING result if any, otherwise NULL.
  * ----------------------------------------------------------------
  */
-static TupleTableSlot *
+TupleTableSlot *
 ExecUpdate(ItemPointer tupleid,
 		   HeapTuple oldtuple,
 		   TupleTableSlot *slot,
diff --git a/src/backend/postmaster/bgworker.c b/src/backend/postmaster/bgworker.c
index 699c934..fc998cd 100644
--- a/src/backend/postmaster/bgworker.c
+++ b/src/backend/postmaster/bgworker.c
@@ -93,6 +93,9 @@ struct BackgroundWorkerHandle
 
 static BackgroundWorkerArray *BackgroundWorkerData;
 
+/* Enables registration of internal background workers. */
+bool internal_bgworker_registration_in_progress = false;
+
 /*
  * Calculate shared memory needed.
  */
@@ -745,7 +748,8 @@ RegisterBackgroundWorker(BackgroundWorker *worker)
 		ereport(DEBUG1,
 		 (errmsg("registering background worker \"%s\"", worker->bgw_name)));
 
-	if (!process_shared_preload_libraries_in_progress)
+	if (!process_shared_preload_libraries_in_progress &&
+		!internal_bgworker_registration_in_progress)
 	{
 		if (!IsUnderPostmaster)
 			ereport(LOG,
